/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ChannelLocation type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ChannelLocation{}

// ChannelLocation struct for ChannelLocation
type ChannelLocation struct {
	Id string `json:"id"`
	Type string `json:"type"`
	TagName string `json:"tag_name"`
	ExternalName string `json:"external_name"`
	OrganizationId string `json:"organization_id"`
	Organization *Organization `json:"organization,omitempty"`
	Channel *Channel `json:"channel,omitempty"`
	Name string `json:"name"`
	ImageUrl *string `json:"image_url,omitempty"`
	CreatedAt string `json:"created_at"`
	UpdatedAt string `json:"updated_at"`
	ChannelId *string `json:"channel_id,omitempty"`
	Address *ContactAddress `json:"address,omitempty"`
	ExternalReferences map[string]interface{} `json:"external_references,omitempty"`
	Default *bool `json:"default,omitempty"`
	Coordinates *ChannelLocationCoordinates `json:"coordinates,omitempty"`
	Billing *bool `json:"billing,omitempty"`
	Scope string `json:"scope"`
}

// NewChannelLocation instantiates a new ChannelLocation object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewChannelLocation(id string, type_ string, tagName string, externalName string, organizationId string, name string, createdAt string, updatedAt string, scope string) *ChannelLocation {
	this := ChannelLocation{}
	this.Id = id
	this.Type = type_
	this.TagName = tagName
	this.ExternalName = externalName
	this.OrganizationId = organizationId
	this.Name = name
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	this.Scope = scope
	return &this
}

// NewChannelLocationWithDefaults instantiates a new ChannelLocation object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewChannelLocationWithDefaults() *ChannelLocation {
	this := ChannelLocation{}
	return &this
}

// GetId returns the Id field value
func (o *ChannelLocation) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ChannelLocation) SetId(v string) {
	o.Id = v
}

// GetType returns the Type field value
func (o *ChannelLocation) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *ChannelLocation) SetType(v string) {
	o.Type = v
}

// GetTagName returns the TagName field value
func (o *ChannelLocation) GetTagName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TagName
}

// GetTagNameOk returns a tuple with the TagName field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetTagNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TagName, true
}

// SetTagName sets field value
func (o *ChannelLocation) SetTagName(v string) {
	o.TagName = v
}

// GetExternalName returns the ExternalName field value
func (o *ChannelLocation) GetExternalName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ExternalName
}

// GetExternalNameOk returns a tuple with the ExternalName field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetExternalNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ExternalName, true
}

// SetExternalName sets field value
func (o *ChannelLocation) SetExternalName(v string) {
	o.ExternalName = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *ChannelLocation) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *ChannelLocation) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetOrganization returns the Organization field value if set, zero value otherwise.
func (o *ChannelLocation) GetOrganization() Organization {
	if o == nil || IsNil(o.Organization) {
		var ret Organization
		return ret
	}
	return *o.Organization
}

// GetOrganizationOk returns a tuple with the Organization field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetOrganizationOk() (*Organization, bool) {
	if o == nil || IsNil(o.Organization) {
		return nil, false
	}
	return o.Organization, true
}

// HasOrganization returns a boolean if a field has been set.
func (o *ChannelLocation) HasOrganization() bool {
	if o != nil && !IsNil(o.Organization) {
		return true
	}

	return false
}

// SetOrganization gets a reference to the given Organization and assigns it to the Organization field.
func (o *ChannelLocation) SetOrganization(v Organization) {
	o.Organization = &v
}

// GetChannel returns the Channel field value if set, zero value otherwise.
func (o *ChannelLocation) GetChannel() Channel {
	if o == nil || IsNil(o.Channel) {
		var ret Channel
		return ret
	}
	return *o.Channel
}

// GetChannelOk returns a tuple with the Channel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetChannelOk() (*Channel, bool) {
	if o == nil || IsNil(o.Channel) {
		return nil, false
	}
	return o.Channel, true
}

// HasChannel returns a boolean if a field has been set.
func (o *ChannelLocation) HasChannel() bool {
	if o != nil && !IsNil(o.Channel) {
		return true
	}

	return false
}

// SetChannel gets a reference to the given Channel and assigns it to the Channel field.
func (o *ChannelLocation) SetChannel(v Channel) {
	o.Channel = &v
}

// GetName returns the Name field value
func (o *ChannelLocation) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *ChannelLocation) SetName(v string) {
	o.Name = v
}

// GetImageUrl returns the ImageUrl field value if set, zero value otherwise.
func (o *ChannelLocation) GetImageUrl() string {
	if o == nil || IsNil(o.ImageUrl) {
		var ret string
		return ret
	}
	return *o.ImageUrl
}

// GetImageUrlOk returns a tuple with the ImageUrl field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetImageUrlOk() (*string, bool) {
	if o == nil || IsNil(o.ImageUrl) {
		return nil, false
	}
	return o.ImageUrl, true
}

// HasImageUrl returns a boolean if a field has been set.
func (o *ChannelLocation) HasImageUrl() bool {
	if o != nil && !IsNil(o.ImageUrl) {
		return true
	}

	return false
}

// SetImageUrl gets a reference to the given string and assigns it to the ImageUrl field.
func (o *ChannelLocation) SetImageUrl(v string) {
	o.ImageUrl = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *ChannelLocation) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *ChannelLocation) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *ChannelLocation) GetUpdatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetUpdatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *ChannelLocation) SetUpdatedAt(v string) {
	o.UpdatedAt = v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *ChannelLocation) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *ChannelLocation) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *ChannelLocation) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *ChannelLocation) GetAddress() ContactAddress {
	if o == nil || IsNil(o.Address) {
		var ret ContactAddress
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetAddressOk() (*ContactAddress, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *ChannelLocation) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given ContactAddress and assigns it to the Address field.
func (o *ChannelLocation) SetAddress(v ContactAddress) {
	o.Address = &v
}

// GetExternalReferences returns the ExternalReferences field value if set, zero value otherwise.
func (o *ChannelLocation) GetExternalReferences() map[string]interface{} {
	if o == nil || IsNil(o.ExternalReferences) {
		var ret map[string]interface{}
		return ret
	}
	return o.ExternalReferences
}

// GetExternalReferencesOk returns a tuple with the ExternalReferences field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetExternalReferencesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.ExternalReferences) {
		return map[string]interface{}{}, false
	}
	return o.ExternalReferences, true
}

// HasExternalReferences returns a boolean if a field has been set.
func (o *ChannelLocation) HasExternalReferences() bool {
	if o != nil && !IsNil(o.ExternalReferences) {
		return true
	}

	return false
}

// SetExternalReferences gets a reference to the given map[string]interface{} and assigns it to the ExternalReferences field.
func (o *ChannelLocation) SetExternalReferences(v map[string]interface{}) {
	o.ExternalReferences = v
}

// GetDefault returns the Default field value if set, zero value otherwise.
func (o *ChannelLocation) GetDefault() bool {
	if o == nil || IsNil(o.Default) {
		var ret bool
		return ret
	}
	return *o.Default
}

// GetDefaultOk returns a tuple with the Default field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetDefaultOk() (*bool, bool) {
	if o == nil || IsNil(o.Default) {
		return nil, false
	}
	return o.Default, true
}

// HasDefault returns a boolean if a field has been set.
func (o *ChannelLocation) HasDefault() bool {
	if o != nil && !IsNil(o.Default) {
		return true
	}

	return false
}

// SetDefault gets a reference to the given bool and assigns it to the Default field.
func (o *ChannelLocation) SetDefault(v bool) {
	o.Default = &v
}

// GetCoordinates returns the Coordinates field value if set, zero value otherwise.
func (o *ChannelLocation) GetCoordinates() ChannelLocationCoordinates {
	if o == nil || IsNil(o.Coordinates) {
		var ret ChannelLocationCoordinates
		return ret
	}
	return *o.Coordinates
}

// GetCoordinatesOk returns a tuple with the Coordinates field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetCoordinatesOk() (*ChannelLocationCoordinates, bool) {
	if o == nil || IsNil(o.Coordinates) {
		return nil, false
	}
	return o.Coordinates, true
}

// HasCoordinates returns a boolean if a field has been set.
func (o *ChannelLocation) HasCoordinates() bool {
	if o != nil && !IsNil(o.Coordinates) {
		return true
	}

	return false
}

// SetCoordinates gets a reference to the given ChannelLocationCoordinates and assigns it to the Coordinates field.
func (o *ChannelLocation) SetCoordinates(v ChannelLocationCoordinates) {
	o.Coordinates = &v
}

// GetBilling returns the Billing field value if set, zero value otherwise.
func (o *ChannelLocation) GetBilling() bool {
	if o == nil || IsNil(o.Billing) {
		var ret bool
		return ret
	}
	return *o.Billing
}

// GetBillingOk returns a tuple with the Billing field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetBillingOk() (*bool, bool) {
	if o == nil || IsNil(o.Billing) {
		return nil, false
	}
	return o.Billing, true
}

// HasBilling returns a boolean if a field has been set.
func (o *ChannelLocation) HasBilling() bool {
	if o != nil && !IsNil(o.Billing) {
		return true
	}

	return false
}

// SetBilling gets a reference to the given bool and assigns it to the Billing field.
func (o *ChannelLocation) SetBilling(v bool) {
	o.Billing = &v
}

// GetScope returns the Scope field value
func (o *ChannelLocation) GetScope() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Scope
}

// GetScopeOk returns a tuple with the Scope field value
// and a boolean to check if the value has been set.
func (o *ChannelLocation) GetScopeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Scope, true
}

// SetScope sets field value
func (o *ChannelLocation) SetScope(v string) {
	o.Scope = v
}

func (o ChannelLocation) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ChannelLocation) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["type"] = o.Type
	toSerialize["tag_name"] = o.TagName
	toSerialize["external_name"] = o.ExternalName
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.Organization) {
		toSerialize["organization"] = o.Organization
	}
	if !IsNil(o.Channel) {
		toSerialize["channel"] = o.Channel
	}
	toSerialize["name"] = o.Name
	if !IsNil(o.ImageUrl) {
		toSerialize["image_url"] = o.ImageUrl
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.ExternalReferences) {
		toSerialize["external_references"] = o.ExternalReferences
	}
	if !IsNil(o.Default) {
		toSerialize["default"] = o.Default
	}
	if !IsNil(o.Coordinates) {
		toSerialize["coordinates"] = o.Coordinates
	}
	if !IsNil(o.Billing) {
		toSerialize["billing"] = o.Billing
	}
	toSerialize["scope"] = o.Scope
	return toSerialize, nil
}

type NullableChannelLocation struct {
	value *ChannelLocation
	isSet bool
}

func (v NullableChannelLocation) Get() *ChannelLocation {
	return v.value
}

func (v *NullableChannelLocation) Set(val *ChannelLocation) {
	v.value = val
	v.isSet = true
}

func (v NullableChannelLocation) IsSet() bool {
	return v.isSet
}

func (v *NullableChannelLocation) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableChannelLocation(val *ChannelLocation) *NullableChannelLocation {
	return &NullableChannelLocation{value: val, isSet: true}
}

func (v NullableChannelLocation) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableChannelLocation) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


